; ================== draw one frame

frameBlobs	proc	near
	call	moveBlobs
	mov	cx,NUMBLOBS
	mov	di,offset blobs
draw_one_blob:
	pusha
	mov	ax,screenBuf
	mov	es,ax
	mov	di,[di+4]
	mov	ax,spriteSeg
	mov	ds,ax
	xor	si,si
	mov	bx,2*RADIUS
draw_line:
	mov	cx,2*RADIUS
draw_one:
	lodsb
	add	al,es:[di]
	jnc	do_draw_one
	mov	al,0FFh
do_draw_one:
	stosb
	loop	draw_one
	add	di,320-2*RADIUS
	dec	bx
	jnz	draw_line
	popa
	push	cs
	pop	ds
	add	di,6
	loop	draw_one_blob

	push	es
	pop	ds
	xor	cx,cx
	xor	si,si
	xor	di,di
	xor	bx,bx
blurBuf_1:			; blur buffer
	mov	al,[si-320]
	mov	bl,[si-1]
	add	ax,bx
	mov	bl,[si+1]
	add	ax,bx
	mov	bl,[si+320]
	add	ax,bx
	shr	ax,2
	stosb
	inc	si
	loop	blurBuf_1
blurBuf_2:			; blur buffer once again
	mov	al,[si-320]
	mov	bl,[si-1]
	add	ax,bx
	mov	bl,[si+1]
	add	ax,bx
	mov	bl,[si+320]
	add	ax,bx
	shr	ax,2
	stosb
	inc	si
	loop	blurBuf_2
;blurBuf_3:			; blur buffer once again
;	mov	al,[si-320]
;	mov	bl,[si-1]
;	add	ax,bx
;	mov	bl,[si+1]
;	add	ax,bx
;	mov	bl,[si+320]
;	add	ax,bx
;	shr	ax,2
;	stosb
;	inc	si
;	loop	blurBuf_3

fromGrad_1:			; convert from gradient image to my palette
	lodsb
	shr	al,3
	add	al,80h
	stosb
	loop	fromGrad_1

	push	cs
	pop	ds
	mov	si,offset m_blobs
	call	printStrBeg
	ret
frameBlobs	endp

; ================== pre-render blobs

makeSprite	proc	near
	mov	ax,spriteSeg
	mov	es,ax
	xor	di,di
	mov	bx,-RADIUS
sprite_yloop:
	mov	iY,bx
	mov	cx,-RADIUS
sprite_xloop:
	mov	iX,cx
	fild	iX
	fmul	st(0),st(0)
	fild	iY
	fmul	st(0),st(0)
	fadd
	fiadd	i1
	fidivr	iRadius
	fistp	tmp16
	mov	ax,tmp16
	or	ah,ah
	jz	sprite_putpixel
	mov	al,0FFh
sprite_putpixel:
	stosb
	inc	cx
	cmp	cx,RADIUS
	jne	sprite_xloop
	inc	bx
	cmp	bx,RADIUS
	jne	sprite_yloop
	ret
makeSprite	endp

; ================== move blobs

moveBlobs	proc	near
	mov	cx,NUMBLOBS
	mov	si,offset blobs
	mov	di,offset paths
move_one_blob:
	fild	frame
	fld	st(0)
	fidiv	word ptr [di]
 	fsin
	fimul	word ptr [di+2]
	fistp	word ptr [si]

;	fild	frame
	fidiv	word ptr [di+4]
	fcos
	fimul	word ptr [di+6]
	fistp	word ptr [si+2]

	mov	ax,[si+2]
;	add	ax,100-RADIUS		; radius is 100

;	mov	bx,ax
;	shl	ax,8
;	shl	bx,6
;	add	ax,bx
	mov	bx,320
	mul	bx

	add	ax,[si]
	add	ax,160-RADIUS
	mov	[si+4],ax
	add	si,6
	add	di,8
	loop	move_one_blob
	ret
moveBlobs	endp