; ================== some controlling defs

; === party/release?
RELEASE		equ	0

; === timer interrupt frequency used for fps counter
FPS		equ	50
FPS_DIV		equ	1234DDh/FPS

; === 2D metaballs (aka blobs)
RADIUS		equ	100	; sprite (blob) radius
NUMBLOBS	equ	5	; blobs amount

; === metatunnel
TXVAL1	equ	100		; magic texture generation constant
TXVAL2	equ	107

; === 3D engine
MAXVERTS	equ	700
MAXFACES	equ	1400

; === trefoil knot
RINGSEGS	equ	97	; warning: should be sync'd with fPiRing/Cyln
CYLNSEGS	equ	7

; === 3D isosurfaces (aka metaballs)
XGRID2		equ	8
YGRID2		equ	5
ZGRID2		equ	5
XGRID		equ	(2*XGRID2+1)
YGRID		equ	(2*YGRID2+1)
ZGRID		equ	(2*ZGRID2+1)
HASHDELTA	equ	3117
AMBIENT		equ	10