; ================== palette setup routine

palInterp	proc	near
r0	equ	byte ptr [bp+10]
g0	equ	byte ptr [bp+9]
b0	equ	byte ptr [bp+8]
r1	equ	byte ptr [bp+6]
g1	equ	byte ptr [bp+5]
b1	equ	byte ptr [bp+4]

	push	bp
	mov	bp,sp
	pusha
	mov	cx,10h
	mov	bl,1
ipal1:
	mov	al,r1
	sub	al,r0
	imul	bl
	shr	ax,4
	add	al,r0
	out	dx,al

	dec	bp
	mov	al,r1
	sub	al,r0
	imul	bl
	shr	ax,4
	add	al,r0
	out	dx,al

	dec	bp
	mov	al,r1
	sub	al,r0
	imul	bl
	shr	ax,4
	add	al,r0
	out	dx,al

;	mov	al,g1
;	sub	al,g0
;	imul	bl
;	shr	ax,4
;	add	al,g0
;	out	dx,al
;	mov	al,b1
;	sub	al,b0
;	imul	bl
;	shr	ax,4
;	add	al,b0
;	out	dx,al

	inc	bx
	inc	bp
	inc	bp
	loop	ipal1
	popa
	pop	bp
	ret	8
palInterp	endp

palInterpBCW	proc	near
	mov	bp,sp
	xor	ax,ax
	push	ax
	push	ax
	push	word ptr [bp+4]
	push	word ptr [bp+2]
	call	palInterp
	push	word ptr [bp+4]
	push	word ptr [bp+2]
	mov	ax,03F3Fh
	push	ax
	push	ax
	call	palInterp
	ret	4
palInterpBCW	endp

initVideo	proc	near
	mov	ax,0013h
	int	10h

	xor	ax,ax
	mov	dx,03C8h
	out	dx,al
	inc	dx

;  for (i=0; i<8; i++)
;    palMakeBCW(pal+i*32*3, 16+4*i+((i+2)%3)*3, 16+3*i+(i&1)*4, 16+2*i+(i%3)*2, 18, 14);

	mov	cx,08h
;	xor	bx,bx	; bl=r
;	xor	si,si	; dh=g dl=b
	mov	bx,1010h
	mov	si,bx
pal1:
	push	bx
	push	si
	call	palInterpBCW
	add	bl,04h
	add	si,0302h
;	add	si,0700h
	loop	pal1

	ret
initVideo	endp

; ================== moves screen buffer to screen

blurToScr	proc	near
;	mov	dx,03DAh
;wait_1:
;	in	al,dx
;	test	al,08h
;	jz	wait_1
;wait_2:
;	in	al,dx
;	test	al,08h
;	jnz	wait_2

	mov	bl,phase
	mov	ax,screenBuf
	mov	ds,ax
	push	0A000h
	pop	es

	xor	si,si
	xor	di,di
	xor	cx,cx
copy_1:
	lodsb
	mov	ah,al
	and	ax,0E01Fh
	add	al,bl
	cmp	al,01Fh
	jbe	no_phase_clip
	mov	al,01Fh
no_phase_clip:
	add	al,ah
	stosb
	loop	copy_1

	push	cs
	pop	ds
	ret
blurToScr	endp

; ================== clear rendering buffer

clearBuf	proc	near
	mov	ax,screenBuf
	mov	es,ax
	xor	ax,ax
	xor	di,di
	mov	cx,8000h
	rep	stosw
	ret
clearBuf	endp

; ================== executes a specified effect with sync and stuff

runEffect	proc	near
	xor	ax,ax
	mov	frame,ax
if	RELEASE eq 0
	mov	es,ax
endif
run_frame:
	mov	al,0
	cmp	frame,01Fh
	ja	zero_phase
	mov	al,01Fh
	sub	al,byte ptr frame
zero_phase:
	mov	phase,al
	in	al,60h
	dec	al
	jz	exit
if	RELEASE eq 1
	mov	ax,tick
else
	mov	ax,es:[046Ch]
endif
	pusha
	push	es
	call	clearBuf
	call	bx
	call	blurToScr
	pop	es
	popa
wait_sync:
	mov	dx,ax
if	RELEASE eq 1
	sub	dx,tick
else
	sub	dx,es:[046Ch]		; ax=syncStart-tick
endif
	jz	wait_sync
	sub	frame,dx
	add	cx,dx
	jge	run_frame
runEffect_done:
	ret
runEffect	endp