.386
.387
.model	tiny
jumps

code	segment use16 public 'code'
assume	cs:code,ds:code
org	100h

; ================== include controlling definitions

include	defs.i

; ================== main routine

main:
	db	1000h dup (?)	; for packer

	mov	ax,cs		; init memory
	mov	di,offset segments
	add	ah,10h
	stosw
	add	ah,10h
	stosw
	add	ah,10h
	stosw
	add	ah,10h
	stosw
	add	ah,10h
	stosw
	add	ah,10h
	stosw

;	mov	ax,cs		; init memory
;	add	ah,10h
;	mov	phongMapSeg,ax
;	add	ah,10h
;	mov	screenBuf,ax
;	add	ah,10h
;	mov	spriteSeg,ax
;;	push	ax
;	add	ah,10h
;	mov	tex1,ax
;	add	ah,10h
;	mov	tex2,ax

	mov	ax,1130h
	mov	bh,06h
	int	10h
	mov	si,bp
	mov	fontofs,bp
	mov	fontseg,es

	call	initTables
	call	makePhongMap
	call	makeSprite

	xor	bx,bx
	mov	ecx,3
	mov	edi,500
	mov	eax,017091977h
	mov	ax,tex2
	mov	ds,ax
	call	txPlasmaMap_
	push	cs
	pop	ds
	call	initVideo

	mov	bx,FPS_DIV	; init timer
	mov	al,34h
	out	43h,al
	mov	al,bl
	out	40h,al
	mov	al,bh
	out	40h,al
if	RELEASE eq 1
	mov	ax,3508h
	int	21h
	mov	ofs08,bx
	mov	seg08,es
	mov	ax,2508h
	mov	dx,offset new08
	int	21h
endif

	mov	bx,offset frameLogo
	mov	cx,150
	call	runEffect
	mov	bx,offset frameBlobs
	mov	cx,400
	call	runEffect
	mov	bx,offset frameTunnel
	mov	cx,400
	call	runEffect
	mov	bx,offset frameKnot
	mov	cx,400
	call	runEffect
	mov	bx,offset frameBraid
	mov	cx,500
	call	runEffect
	mov	bx,offset frameMetaballs
	mov	cx,650
	call	runEffect

	mov	es,phongMapSeg
	xor	di,di
	xor	ax,ax
	mov	cx,8000h
	rep	stosw
	mov	ch,01h
water_frame:
	push	cx
	mov	es,phongMapSeg
	mov	ds,screenBuf
	mov	cs:screenBuf,es
	mov	cs:phongMapSeg,ds
	xor	si,si
	xor	di,di
	mov	cx,64000
water_pix:
	xor	ax,ax
	xor	bx,bx
	mov	al,[si-1]
	add	bx,ax
	mov	al,[si+1]
	add	bx,ax
	mov	al,[si-320]
	add	bx,ax
	mov	al,[si+320]
	add	bx,ax
	shr	bx,1
	mov	al,es:[di]
	sub	bx,ax
	jns	no_waterpix_clip
	xor	bx,bx
no_waterpix_clip:
	xchg	ax,bx
	stosb
	inc	si
	loop	water_pix
	push	0A000h
	pop	es
	xor	si,si
	xor	di,di
	mov	cx,32000
	rep	movsw
	push	cs
	pop	ds
	pop	cx
	loop	water_frame

exit:
	xor	bx,bx		; restore timer state
	push	bx		; make ret addr
	mov	al,34h
	out	43h,al
	mov	al,bl
	out	40h,al
	mov	al,bh
	out	40h,al
if	RELEASE eq 1
	mov	ax,seg08
	mov	dx,ofs08
	mov	ds,ax
	mov	ax,2508h
	int	21h
endif

	mov	ax,0003h
	int	10h
	ret

; ================== include everything

frameLogo	proc	near
	mov	si,offset m_title
	mov	di,(100-8)*320+160-(8+7)*4+8
	call	printStr
	ret
frameLogo	endp

if	RELEASE eq 1
new08:
	push	ax
	inc	cs:tick
	mov	al,20h
	out	20h,al
	pop	ax
	iret
endif

include		service.i	; code
include		2dblobs.i
include		text.i
include		tunnel.i
include		engine.i
include		knot.i
include		metaballs.i

include		2dblobs.d	; data
include		tunnel.d
include		knot.d
include		engine.d
include		metaballs.d
include		messages.d

include		2dblobs.v	; variables
include		text.v
include		tunnel.v
include		knot.v
include		metaballs.v
include		engine.v

; ================== shared variables

seg08		dw	?
ofs08		dw	?

frame_scaled	label	dword	; for metatunnel
		db	?
frame		dw	?
		db	?

tick		dw	?
phase		db	?

iX		dw	?
iY		dw	?
iZ		dw	?

segments	label	byte
screenBuf	dw	?
phongMapSeg	dw	?
spriteSeg	dw	?
tex1		dw	?
tex2		dw	?

tmpf		dd	?
tmp16		dw	?

stackbuf	dw	256 dup (?)

code	ends
	end	main