; ================== draw one frame

frameTunnel	proc	near
	call	moveBlobs
	call	renderTunnel
;	call	toGradient
	mov	si,offset m_tunnel
	call	printStrBeg
	ret
frameTunnel	endp

; ================== rendering tunnel texturemap

;makeTunnelTexture	proc	near
;	mov	ax,tex1
;	mov	es,ax
;
;		xor	di, di
;		xor	al, al
;		mov	cx, 32768
;		rep	stosb
;		push	di
;
;		mov	ch, 1				; cx = 256
;		mov	al, TXVAL1 			; starting value
;		rep	stosb
;		mov	ch,127
;
;BackGround:	mov	ax, 130bh
;Ck1:		imul	ax, 1111h
;		mov	word ptr [Ck1+2], ax		; selfmodifying code
;		mov	bl,5
;		cwd
;		idiv	bx
;		mov	al, dl
;		xor	dx, dx
;Ck3:		mov	dl, es:[di-256]
;Ck2:		add	dx, TXVAL2
;		shr	dx, 1
;		add	al, dl
;		jns	NoBelowNul
;		xor	al, al
;NoBelowNul:	mov	byte ptr [Ck2+2], al		 ; selfmodifying code
;		mov	byte ptr [Background+2], al	 ; selfmodifying code
;		stosb
;		Loop	background
;
;	push	es
;	pop	ds
;	pop	si
;	push	si
;	pop	di
;	dec	di
;	push	si
;	pop	cx
;copy_tx_1:
;	lodsb
;	add	al,al
;	mov	[si-1],al
;	stosb
;	dec	di
;	dec	di
;	loop	copy_tx_1
;
;	push	cs
;	pop	ds
;	ret
;makeTunnelTexture	endp

; ================== raytraced metatunnel

renderLinePart	proc	near
	pusha
	mov	eax,u1
	sub	eax,u0
	sar	eax,3
	mov	dudx,ax
	mov	eax,v1
	sub	eax,v0
	sar	eax,3
	mov	dvdx,ax

	push	es
	mov	ax,phongMapSeg
	mov	es,ax
	mov	ax,word ptr u0
	mov	dx,word ptr v0
	mov	cx,8
tunnel_inner:
	mov	bl,ah
	mov	bh,dh
	mov	di,es:[bx]
	mov	bl,fs:[bx]
	add	bx,di
	mov	gs:[bp],bl
	add	ax,0505h
	org	$-2
dudx	dw	?
	add	dx,0505h
	org	$-2
dvdx	dw	?
	inc	bp
	loop	tunnel_inner
	pop	es

	popa
	ret
renderLinePart	endp

add_blob	proc	near
	fild	word ptr [bp]
	fiadd	i160
	fisub	iX
	fild	word ptr [bp+2]
	fiadd	i100
	fisub	iY
	fld	st(1)
	fld	st(1)
	fpatan
	fabs
	faddp	st(4),st(0)
	fmul	st(0),st(0)
	fxch	st(1)
	fmul	st(0),st(0)
	fadd
	fiadd	i256
	fld1
	fdivrp
	fadd
	ret
add_blob	endp

renderTunnel	proc	near
	push	cs
	pop	es
	mov	si,offset fverts	; using this buffer instead of uuvv
	xor	cx,cx
yy_loop:
	mov	iY,cx
	xor	dx,dx
xx_loop:
	mov	iX,dx

	fldz
	fldz
	mov	bp,offset blob1
	call	add_blob
	mov	bp,offset blob2
	call	add_blob
	mov	bp,offset blob3
	call	add_blob
	fsqrt
	fimul	i8k
	fiadd	frame_scaled
	fistp	dword ptr [si+4]

;	fild	iX
;	fisub	i160
;	fild	i100
;	fisub	iY
;	fild	blob1x
;	fiadd	blob2x
;	fiadd	blob3x
;	fidiv	i3
;	fiadd	i160
;	fisubr	iX
;	fild	blob1y
;	fiadd	blob2y
;	fiadd	blob3y
;	fidiv	i3
;	fiadd	i100
;	fisub	iY
;	fpatan
	fmul	fPiScale
;	fiadd	frame_scaled
	fistp	dword ptr [si]

	add	si,8
	add	dx,8
	cmp	dx,320
	jbe	xx_loop
	add	cx,8
	cmp	cx,200
	jbe	yy_loop

	mov	ax,screenBuf
	mov	gs,ax
;	mov	ax,tex1
;	mov	fs,ax
	mov	ax,tex2
	mov	fs,ax

	xor	bp,bp
	mov	si,offset fverts	; using this buffer instead of uuvv
	mov	cx,25
yy_render:
	mov	dx,40
xx_render:
	pusha
	mov	di,offset u0
	mov	cx,8
	rep	movsw
	add	si,8*41-16
	mov	cl,4
calc_delta_1:
	lodsd
	sub	eax,[si-4-8*41]
	sar	eax,3
	stosd
	loop	calc_delta_1

	mov	bx,8
part_loop:
	call	renderLinePart
	mov	cl,4
	mov	si,offset du0
add_deltas:
	lodsd
	add	[si-20],eax
	loop	add_deltas
	add	bp,320
	dec	bx
	jnz	part_loop

	popa
	add	bp,8
	add	si,8
	dec	dx
	jnz	xx_render
	add	bp,7*320
	add	si,8
	loop	yy_render

	ret
renderTunnel	endp